*******************************************************************************************
* Program....: GetDrv.PRG
* Version....: 1.0
* Author.....: Gerry White
* Date.......: July 26, 1996
* Notice.....: Copyright (c) 1996 Gerry White
* ...........: All rights reserved.
* Compiler...: FoxPro 2.6a
* Abstract...: Returns drive letter for server name passed in
* Changes....:
*******************************************************************************************
PARAMETER cSrvrReq			&& server requested
PRIVATE cDrv
STORE SPACE(0) TO cDrv

IF TYPE("cSrvrReq")#"C" OR EMPTY(cSrvrReq)
	WAIT CLEAR
	WAIT WINDOW "Incorrect call for GetDrv() - expected string in quotes." NOWAIT
	RETURN
ENDIF

** Loop through all possible DOS drives **
FOR nDrvCntr = ASC("D") TO ASC("Z")
	** What's the volume name for this drive? **
	cDrvVolNam = ALLTRIM(UPPER(VOLUME( CHR(nDrvCntr) )))
	** Now what's its server name? **
	cSrvrNam   = GetSvc(cDrvVolNam)
	IF cSrvrNam == UPPER(ALLTRIM(cSrvrReq))		&& Does it match what was received?
		cDrv = CHR(nDrvCntr) + ":"					&& We have a winner! (weiner?)
		EXIT
	ENDIF
ENDFOR &&* DrvCntr = "C" TO "Z"

RETURN cDrv		&& return (drive letter plus ":") or ""

*******************************************************************************************
* Procedure...: VOLUME
* Called by...: Services
*
* Abstract....: Gets volume name of drive passed in
*
* Parameters..:
*
* Notes.......:
*******************************************************************************************
PROCEDURE VOLUME
PARAMETER drive
string = drive + ':'
DIMENSION temparray(1)
=ADIR(temparray,(string),'V')
RETURN temparray(1)

*******************************************************************************************
* Procedure...: GetSvc
* Called by...: Services
*
* Abstract....: Returns service name stored in volume name
*
* Parameters..:
*
* Notes.......:
*******************************************************************************************
PROCEDURE GetSvc
PARAMETERS SvcInput
UsrName = ""
** Determine the service name of volume name passed in **
IF RAT("%",SvcInput)<>0		&& get rid of user's login name, if present -- i.e.,%GWHITE
	UsrName = SUBSTR(SvcInput,RAT("%",SvcInput)+1)
	SvcInput = SUBSTR(SvcInput,1,RAT("%",SvcInput)-1)
ENDIF
IF RAT("\",SvcInput)<>0		&& returns name after last backslash (IHS003\BMODR gives BMODR)
	SvcInput = SUBSTR(SvcInput,RAT("\",SvcInput)+1)
ENDIF
SvcName = SvcInput
RETURN SvcName
** EOF: GetDrv.PRG **

